#===============================================================================
#	Get-VM-Status
#
#	w肵z}VJnAHeartbeartT[rXJn܂ő҂
#	Start-VM ́A~/ۑ ԂVMɑ΂ėLȂ̂ŕ֗
#===============================================================================
Function Get-VM-State($HostName, $VMName)
{
	$ret = ""
	
	try {
	
		$vm = Get-VM -Name $VMName -ComputerName $HostName -ErrorAction stop	# VM擾
		$ret = $vm.State.ToString()
		
	}
	catch {
		$ret = $Error[0].ToString()
	}
	
	return $ret
}

#===============================================================================
#	Start-VM-Wait-Heartbeat
#
#	w肵z}VJnAHeartbeartT[rXJn܂ő҂
#	Start-VM ́A~/ۑ ԂVMɑ΂ėLȂ̂ŕ֗
#===============================================================================
Function Start-VM-Wait-Heartbeat($HostName, $VMName, $WaitMinute)
{
	$ret = ""
	$WaitSec = $WaitMinute * 60
	
	try {
	
		$vm = Get-VM -Name $VMName -ComputerName $HostName -ErrorAction stop	# VM擾
		if ($vm.State -eq "Running") {											# 쒆Ȃ炷߂
			$ret = "ɋNĂ܂"
			return $ret		
		}
		
		Start-VM -VM $vm > $null												# VMJn
		
		# 10bHeartbertT[rX`FbNONɂȂ܂ŌJԂBw莞Ԓ߂Ŕ
		$step = 10
		$i = 0		
		do {
			Start-Sleep -Seconds $step
			$i += $step
			# T[rXw肵ď𓾂c{ꖼłȂƔȂ!
			$hb = Get-VMIntegrationService -VM $vm -Name "n[gr[g"
			if ($hb.PrimaryStatusDescription -eq "OK") {
				break
			}
		} while ($i -lt ($WaitSec))
		
		if ($i -ge $WaitSec) {
			$ret = "JnԂ𒴉߂܂B"
		}
		else {
			$ret = "OK"
		}
		
	}
	catch {
		$ret = $Error[0].ToString()
	}
	
	return $ret
}


#===============================================================================
#	Save-VM-Custom
#
#	w肵z}VۑB Save-VMgB
#===============================================================================
Function Save-VM-Custom($HostName, $VMName)
{
	$ret = ""
	
	try {
	
		$vm = Get-VM -Name $VMName -ComputerName $HostName -ErrorAction stop	# VM擾
		if ($vm.State -ne "Running") {											# 삵ĂȂΖ߂
			$ret = "NĂ܂"
			return $ret		
		}
		
		Save-VM -VM $vm -ErrorAction stop > $null								# VMۑ
		$ret = "OK"
		
	}
	catch {
		$ret = $Error[0].ToString()
	}
	
	return $ret
}

#===============================================================================
#	Create-VM-Snapshot
#
#	w肵z}ṼXibvVbgB Checkpoint-VM gB
#===============================================================================
Function Create-VM-Snapshot($HostName, $VMName)
{
	$ret = ""
	
	try {
	
		$vm = Get-VM -Name $VMName -ComputerName $HostName -ErrorAction stop	# VM擾
		if (-not (($vm.State -eq "Running") -or ($vm.State -eq "Off"))) {		# 쒆/~mF
			$ret = "쒆 or ~ł͂܂"
			return $ret		
		}
		
		Checkpoint-VM -VM $vm -ErrorAction stop > $null							# XibvVbg쐬(ftHĝ)
		$ret = "OK"
		
	}
	catch {
		$ret = $Error[0].ToString()
	}
	
	return $ret
}


#===============================================================================
#	Shutdown-VM
#
#	w肵z}VVbg_EB Stop-VMgB
#===============================================================================
Function Shutdown-VM($HostName, $VMName)
{
	$ret = ""
	
	try {
	
		$vm = Get-VM -Name $VMName -ComputerName $HostName -ErrorAction stop	# VM擾
		if ($vm.State -ne "Running") {											# 삵ĂȂΖ߂
			$ret = "NĂ܂"
			return $ret		
		}
		
		Stop-VM -VM $vm -ErrorAction stop > $null								# VMI
		$ret = "OK"

	}
	catch {
		$ret = $Error[0].ToString()
	}
	
	return $ret
}


#===============================================================================
#	Update-VM
#
#	w肵z}Vɑ΂āApsexec g Windows Update sB
#	Windows Update p̃XNvǵA\ C:\PSScripts\WindowsUpdate ɔzuĂB
#	psexec ŝ߂̊Â͑ʓ|ŁAۂ̊mFB
#	ŁA߂lƂďIԂL^c܂ɕςƋCÂƎv
#===============================================================================
Function Update-VM($HostName, $VMName, $PcName, $User, $Password)
{
	$ret = ""
	$psf = "C:\PSScripts\WindowsUpdate\Run-WinUpdate.ps1"
	
	try {
	
		$vm = Get-VM -Name $VMName -ComputerName $HostName -ErrorAction stop	# VM擾
		if ($vm.State -ne "Running") {											# 삵ĂȂΖ߂
			$ret = "NĂ܂"
			return $ret		
		}
		
		if ($User -eq "") {
			# [U[w肪Ȃꍇ͑샆[U[Łc
			psexec.exe \\$PcName -i -s -high powershell -command $psf
		}
		else {
			psexec.exe \\$PcName -i -s -u $User -p $Password powershell -command $psf
		} 
		$ret = (Get-Date).ToString("yyyy/MM/dd HH:mm:ss")		# sԂ̎擾Ȃ̂ŁAԂL^

	}
	catch {
		$ret = $Error[0].ToString()
	}
	
	return $ret
}


#===============================================================================
#===============================================================================
$input | foreach {

	$HostName = $_.HostName
	$VMName = $_.VirtualMachineName
	$PcName = $_.PcName
	$User = $_.User
	$Password = $_.Password
	$STime = $_.StartTimeMax
	
	switch ($_.Action) {
		#---
		"" {
			Get-VM-State -HostName $HostName -VMName $VMName
		}		
		#---
		"N" {
			Start-VM-Wait-Heartbeat -HostName $HostName -VMName $VMName -WaitMinute $STime
		}		
		#---
		"ۑ" {
			Save-VM-Custom -HostName $HostName -VMName $VMName
		}
		#---
		"XibvVbg" {
			Create-VM-Snapshot -HostName $HostName -VMName $VMName
		}
		#---
		"Vbg_E" {
			Shutdown-VM -HostName $HostName -VMName $VMName
		}
		#---
		"XV" {
			Update-VM -HostName $HostName -VMName $VMName -PcName $Pcname -User $User -Password $Password
		}
		
		#---
		default {
			""
		}		
	}
}
